import java.io.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class SAXReader extends DefaultHandler
{
    static int verbose = 0;
    String textContent;

    SAXReader() {}

    public void parse( String fileName ) {
	DefaultHandler handler = this;
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(fileName), handler );
	} catch (Throwable t) {
            t.printStackTrace();
        }
    }

    /** ******************************************************************
     *
     */
    public static void main(String[] args) {
	(new SAXReader()).parse( "save.xml" );
    }

    //===========================================================
    // SAX DocumentHandler methods
    //===========================================================

    public void startDocument() throws SAXException {
        System.out.println("START DOCUMENT");
    }

    public void endDocument() throws SAXException  {
	System.out.println("END DOCUMENT");
    }

    public void startElement(String namespaceURI,
                             String lName, // local name
                             String qName, // qualified name
                             Attributes attrs)
	throws SAXException    {
	String eName = lName; // element name
        if ("".equals(eName)) eName = qName; // namespaceAware = false
        
	if( eName.equals( "Spieler" ) ) {
	    System.out.println( "Spieler:  " );
	}else if( eName.equals( "Position" ) ) {
	    System.out.println( " Position:" );
            for (int i = 0; i < attrs.getLength(); i++) {
                String aName = attrs.getLocalName(i); // Attr name 
                if ("".equals(aName)) aName = attrs.getQName(i);
		System.out.println("   " + aName + "\t"
				 + attrs.getValue(i) + "");
            }
	} else {
	    if( verbose > 0 ) {
		System.out.println("START_ELM: </"+lName+"|"+qName+">");
	    }
	}
    }

    public void endElement(String namespaceURI,
                           String sName, // simple name
                           String qName  // qualified name
			   )
	throws SAXException {
	String eName = sName; // element name
        if ("".equals(eName)) eName = qName; // namespaceAware = false

	if( eName.equals( "Breite" ) ) {
	    System.out.println( "Breite: " + textContent );
	}else if( eName.equals( "Hoehe" ) ) {
	    System.out.println( "Hoehe: " + textContent );
	}else if( eName.equals( "Name" ) ) {
	    System.out.println( " Name: " + textContent );
	}else if( eName.equals( "Punkte" ) ) {
	    System.out.println( " Punkte: " + textContent );
	}else if( eName.equals( "Spieler" ) ) {
	    System.out.println( "***** ENDE Spieler ***********" );
	} else {
	    if( verbose > 0 ) {
		System.out.println("END_ELM: </"+sName+"|"+qName+">");
	    }
	}
    }

    public void characters(char buf[], int offset, int len)
	throws SAXException {
	textContent = new String(buf, offset, len);
	if( verbose > 0 ) {
	    System.out.println( "CHARS: |" + textContent + "|");
	}
    }
}